<div class="form-container">
  <div class="go-back-btn" *ngIf="!response">
    <button type="button" mat-button color="accent" routerLink="/telecommands">
      <mat-icon>undo</mat-icon>Go Back
    </button>
  </div>
  <form [formGroup]="argsForm" (ngSubmit)="sendTC()" *ngIf="!response">
    <div class="top-text">
      <h3>
        COMMAND: <span class="tcName">{{ command.qualifiedName.split('/')[command.qualifiedName.split('/').length - 1] }}</span>
      </h3>
      <h3 class="arguments">ARGUMENTS:</h3>
    </div>
    <div class="arguments-container">
      <div
        *ngFor="let argument of arguments; let i = index"
        class="necessary-arguments"
      >
        <div
          *ngIf="argument.hasOwnProperty('initialValue') && showInitialValuesArgs"
          class="initialized-args"
        >
          <div class="argument-info">
            <span class="name">
              <span class="argument-label">Argument Name:</span>
              <span class="argument-text">{{ argument.name }}</span>
            </span>
            <!-- <hr class="connect-name-type"> -->
            <span class="type">
              <span class="argument-label">Type:</span>
              <span class="argument-text">{{ argument.type.engType }}</span>
            </span>
          </div>
    
          <mat-form-field *ngIf="argument.name == 'release_time'">
            <input
              required
              type="datetime-local"
              [formControlName]="argument.name"
            />
          </mat-form-field>
  
          <mat-form-field *ngIf="!isNotInteger(argument) || !isNotFloat(argument)">
            <input
              required
              matInput
              [formControlName]="argument.name"
              type="number"
              class="numbers"
              (ngModelChange)="addToFormArray(argument)"
              [min]="getRangeMin(argument)"
              [max]="getRangeMax(argument)"
            />
            <mat-hint
              *ngIf="!isNotInteger(argument) && getRangeMax(argument) > 0"
              align="end"
            >
              [{{ getRangeMin(argument) }},{{ getRangeMax(argument) }}]
            </mat-hint>
          </mat-form-field>
    
          <mat-form-field *ngIf="argument.type.engType == 'string'"> 
            <input
              required
              type="text"
              [formControlName]="argument.name"
            />
          </mat-form-field>
    
          <span *ngIf="!isNotBoolean(argument)" class="boolean-inputs">
            <mat-radio-group [formControlName]="argument.name" required>
              <mat-radio-button [value]="true">True</mat-radio-button>
              <mat-radio-button [value]="false">False</mat-radio-button>
            </mat-radio-group>
          </span>
    
          <div
            *ngIf="!isNotAggregate(argument)"
            [formGroupName]="argument.name"
            class="aggregates"
          >
            <span *ngFor="let member of argument.type.member; let j = index">
              <span class="argument-info">
                <h4>{{ member.name }}</h4>
                <h4>{{ member.type.engType }}</h4>
              </span>
              
              <mat-form-field *ngIf="member.type.engType == 'integer' || member.type.engType == 'float'">
                <input
                  required
                  matInput
                  type="number"
                  [formControlName]="member.name"
                  [min]="getRangeMin(argument)"
                  [max]="getRangeMax(argument)"
                  required
                />
              </mat-form-field>
              <mat-form-field *ngIf="member.type.engType == 'string'">
                <input
                  required
                  matInput
                  type="text"
                  [formControlName]="member.name"
                />
              </mat-form-field>
              <br />
            </span>
          </div>
    
          <div *ngIf="!isNotEnum(argument)" class="enum-arguments">
            <mat-form-field>
              <mat-select
                disableRipple
                name="EnumLabels"
                id="EnumLabels"
                [formControlName]="argument.name"
                placeholder="Select an option"
              >
                <mat-option
                  *ngFor="let enumValue of argument.type.enumValue"
                  [value]="enumValue.label"
                >
                  {{ enumValue.label }}
                </mat-option>
              </mat-select>
            </mat-form-field>
          </div>
    
          <div
            *ngIf="!isNotEnumArray(argument)"
            class="dynamic-enum-arrays"
            [formArrayName]="argument.name"
          >
          <mat-form-field *ngFor="let dynamicNumber of getFormArray(argument).controls;let j = index">
            <mat-select
              [disableRipple]="true"
              [formControlName]="j"
              placeholder="Select an option"
            >
              <mat-option
                *ngFor="let enumValue of argument.type.elementType.enumValue"
                [value]="enumValue.label"
              >
                {{ enumValue.label }}
              </mat-option>
            </mat-select>
          </mat-form-field>
          </div>
    
          <div
            *ngIf="!isNotIntegerArray(argument) || !isNotFloatArray(argument)"
            class="dynamic-integer-arrays"
            [formArrayName]="argument.name"
          >
          <mat-form-field *ngFor="let dynamicNumber of getFormArray(argument).controls;let j = index">
            <input
              required
              matInput
              [formControlName]="j"
              type="number"
              class="numbers"
              [min]="getRangeMin(argument)"
              [max]="getRangeMax(argument)"
            />
          </mat-form-field>
          </div>
    
          <div
            *ngIf="!isNotBinaryArray(argument)"
            class="dynamic-binary-arrays"
            [formArrayName]="argument.name"
          >
          <mat-form-field *ngFor="let dynamicNumber of getFormArray(argument).controls;let j = index">
            <input
              required
              matInput
              type="text"
              [formControlName]="j"
            />
          </mat-form-field>
          </div>
    
          <div
            *ngIf="!isNotAggregateArray(argument)"
            class="dynamic-aggregate-arrays"
            [formArrayName]="argument.name"
          >
            <span
              *ngFor="
                let dynamicNumber of getFormArray(argument).controls;
                let j = index
              "
            >
              <span
                *ngFor="
                  let member of argument.type.elementType.member;
                  let k = index
                "
                [formGroupName]="j"
              >
                <span class="argument-info">
                  <h4>{{ member.name }}</h4>
                  <h4>{{ member.type.engType }}</h4>
                </span>
                
                <mat-form-field *ngIf="member.type.engType == 'integer' || member.type.engType == 'float'">
                  <input
                    required
                    matInput
                    type="number"
                    [min]="getMemberRangeMin(member)"
                    [max]="getMemberRangeMax(member)"
                    [formControlName]="member.name"
                    class="numbers"
                  />
                  <mat-hint
                    *ngIf="
                      member.type.engType == 'integer' &&
                      getMemberRangeMax(member) > 0
                    "
                    align="end"
                  >
                    [{{ getMemberRangeMin(member) }},{{ getMemberRangeMax(member) }}]
                  </mat-hint>
                </mat-form-field>
    
                <mat-form-field *ngIf="member.type.engType == 'string'">
                  <input
                    required
                    matInput
                    type="text"
                    [formControlName]="member.name"
                  />
                </mat-form-field>
    
                <span
                  *ngIf="member.type.engType == 'boolean'"
                  class="boolean-inputs"
                >
                  <mat-radio-group [formControlName]="argument.name" required>
                    <mat-radio-button [value]="true">True</mat-radio-button>
                    <mat-radio-button [value]="false">False</mat-radio-button>
                  </mat-radio-group>
                </span>
    
                <mat-form-field *ngIf="!isNotEnumMember(member)">
                  <mat-select
                    [disableRipple]="true"
                    [formControlName]="member.name"
                    class="enum-arguments"
                    placeholder="Select an option"
                    required
                  >
                    <mat-option
                      *ngFor="let enumValue of member.type.enumValue"
                      [value]="enumValue.label"
                    >
                      {{ enumValue.label }}
                    </mat-option>
                  </mat-select>
                </mat-form-field>
              </span>
            </span>
          </div>
        </div>
  
        <div *ngIf="!argument.hasOwnProperty('initialValue')" class="no-initial-value-arguments">
          <div class="argument-info">
            <span class="name">
              <span class="argument-label">Argument Name:    </span>
              <span class="argument-text">{{ argument.name }}</span>
            </span>
            <!-- <hr class="connect-name-type"> -->
            <span class="type">
              <span class="argument-label">Type:    </span>
              <span class="argument-text">{{ argument.type.engType }}</span>
            </span>
          </div>
    
          <!-- time for time-base-scheduling-->
          <div *ngIf="argument.name == 'release_time'">
            <mat-form-field>
              <input
                matInput
                [ngxMatDatetimePicker]="picker"
                type="text"
                [formControlName]="argument.name"
                required
                (ngModelChange)="newCurrentTime()"
              />
              <mat-datepicker-toggle
                matSuffix
                [for]="$any(picker)"
              ></mat-datepicker-toggle>
              <ngx-mat-datetime-picker #picker></ngx-mat-datetime-picker>
            </mat-form-field>
          </div>
          <mat-form-field *ngIf="!isNotInteger(argument)">
            <input
              required
              matInput
              [formControlName]="argument.name"
              type="number"
              class="numbers"
              [min]="getRangeMin(argument)"
              [max]="getRangeMax(argument)"
              (ngModelChange)="addToFormArray(argument)"
            />
  
            <mat-hint
              *ngIf="getRangeMax(argument) > 0"
              align="end"
            >
              [{{ getRangeMin(argument) }},{{ getRangeMax(argument) }}]
            </mat-hint>
  
          </mat-form-field>
          <mat-form-field *ngIf="!isNotFloat(argument)">
            <input
              required
              matInput
              [formControlName]="argument.name"
              type="number"
              class="numbers"
              [min]="getRangeMin(argument)"
              [max]="getRangeMax(argument)"
              (ngModelChange)="addToFormArray(argument)"
              step="0.5"
              pattern="[0-9]+(\.[0-9]{1,})?%?"
            />
          </mat-form-field>
          
          <!-- here are the number of binary in array -->
    
          <mat-error *ngIf="this.argsForm.get(argument.name)?.errors?.['nowTime']">
            Pick a future date and time
          </mat-error>
          
          <mat-form-field *ngIf="argument.type.engType == 'string'">
            <input
              required
              type="text"
              [formControlName]="argument.name"
              required
            />
          </mat-form-field>
    
          <span *ngIf="!isNotBoolean(argument)" class="boolean-inputs">
            <mat-radio-group [formControlName]="argument.name" required>
              <mat-radio-button [value]="true">True</mat-radio-button>
              <mat-radio-button [value]="false">False</mat-radio-button>
            </mat-radio-group>
          </span>
    
          <div
            *ngIf="!isNotAggregate(argument)"
            [formGroupName]="argument.name"
            class="aggregates"
          >
            <span *ngFor="let member of argument.type.member; let j = index">
              <span class="argument-info">
                <h4>{{ member.name }}</h4>
                <h4>{{ member.type.engType }}</h4>
              </span>
              <mat-form-field *ngIf="member.type.engType == 'integer' || member.type.engType == 'float'">
                <input
                  required
                  matInput
  
                  class="numbers"
                  type="number"
                  [formControlName]="member.name"
                  [min]="getRangeMin(argument)"
                  [max]="getRangeMax(argument)"
                />
              </mat-form-field>
              <mat-form-field *ngIf="member.type.engType == 'string'">
                <input
                  required
                  matInput
                  type="text"
                  [formControlName]="member.name"
                />
              </mat-form-field>
              <mat-form-field *ngIf="!isNotEnumMember(member)" appearance="fill">
                <mat-select
                  [disableRipple]="true"
                  [formControlName]="member.name"
                  class="enum-arguments"
                  placeholder="Select an option"
                  required
                >
                  <mat-option
                    *ngFor="let enumValue of member.type.enumValue"
                    [value]="enumValue.label"
                  >
                    {{ enumValue.label }}
                  </mat-option>
                </mat-select>
              </mat-form-field>
            </span>
          </div>
    
          <div *ngIf="!isNotEnum(argument)" class="enum-arguments">
            <mat-form-field>
              <mat-select
                disableRipple
                name="EnumLabels"
                id="EnumLabels"
                [formControlName]="argument.name"
                placeholder="Select an option"
                required
              >
                <mat-option
                  *ngFor="let enumValue of argument.type.enumValue"
                  [value]="enumValue.label"
                >
                  {{ enumValue.label }}
                </mat-option>
              </mat-select>
            </mat-form-field>
          </div>
    
          <div
            *ngIf="!isNotEnumArray(argument)"
            class="dynamic-enum-arrays"
            [formArrayName]="argument.name"
          >
            <mat-form-field *ngFor="let dynamicNumber of getFormArray(argument).controls;let j = index">
              <mat-select
                [disableRipple]="true"
                [formControlName]="j"
                placeholder="Select an option"
                required
              >
                <mat-option
                  *ngFor="let enumValue of argument.type.elementType.enumValue"
                  [value]="enumValue.label"
                >
                  {{ enumValue.label }}
                </mat-option>
              </mat-select>
            </mat-form-field>
          </div>
    
          <div
            *ngIf="!isNotIntegerArray(argument) || !isNotFloatArray(argument)"
            class="dynamic-integer-arrays"
            [formArrayName]="argument.name"
          >
            <mat-form-field *ngFor="let dynamicNumber of getFormArray(argument).controls;let j = index">
              <input
                required
                matInput
                [formControlName]="j"
                type="number"
                class="numbers"
                [min]="getRangeMin(argument)"
                [max]="getRangeMax(argument)"
              />
            </mat-form-field>
          </div>
    
          <div
            *ngIf="!isNotBinaryArray(argument)"
            class="dynamic-binary-arrays"
            [formArrayName]="argument.name"
          >
            <div
              *ngFor="
                let dynamicNumber of getFormArray(argument).controls;
                let j = index
              "
            >
            <mat-form-field>
              <input
                required
                matInput
                type="text"
                [formControlName]="j"
                placeholder="A-Fa-f0-9"
                pattern="['A-Fa-f0-9']{1,}"
              />
    
              <mat-error
                *ngIf="
                  getFormArray(argument).controls[j].invalid &&
                  getFormArray(argument).controls[j].touched
                "
              >
                insert hex values
              </mat-error>
            </mat-form-field>
              <!-- here are the binary data [] -->
            </div>
          </div>
    
          <div
            *ngIf="!isNotAggregateArray(argument)"
            class="dynamic-aggregate-arrays"
            [formArrayName]="argument.name"
          >
            <span
              *ngFor="
                let dynamicNumber of getFormArray(argument).controls;
                let j = index
              "
            >
              <span
                *ngFor="
                  let member of argument.type.elementType.member;
                  let k = index
                "
                [formGroupName]="j"
              >
                <span class="argument-info">
                  <h4>{{ member.name }}</h4>
                  <h4>{{ member.type.engType }}</h4>
                </span>
                
                <mat-form-field *ngIf="member.type.engType == 'integer' || member.type.engType == 'float'">
                  <input
                    required
                    matInput
                    type="number"
                    class="numbers"
                    [min]="getMemberRangeMin(member)"
                    [max]="getMemberRangeMax(member)"
                    [formControlName]="member.name"
                  />
      
                  <mat-hint
                    *ngIf="
                      member.type.engType == 'integer' &&
                      getMemberRangeMax(member) > 0
                    "
                    align="end"
                  >
                    [{{ getMemberRangeMin(member) }},{{ getMemberRangeMax(member) }}]
                  </mat-hint>
                </mat-form-field>
                <mat-form-field *ngIf="member.type.engType == 'string'">
                  <input
                    required
                    matInput
                    type="text"
                    [formControlName]="argument.name"
                  />
                </mat-form-field>
                <span
                  *ngIf="member.type.engType == 'boolean'"
                  class="boolean-inputs"
                >
                  <mat-radio-group [formControlName]="member.name" required>
                    <mat-radio-button [value]="true">True</mat-radio-button>
                    <mat-radio-button [value]="false">False</mat-radio-button>
                  </mat-radio-group>
                </span>
                
                <mat-form-field *ngIf="!isNotEnumMember(member)">
                  <mat-select
                    [disableRipple]="true"
                    [formControlName]="member.name"
                    class="enum-arguments"
                    placeholder="Select an option"
                    required
                  >
                    <mat-option
                      *ngFor="let enumValue of member.type.enumValue"
                      [value]="enumValue.label"
                    >
                      {{ enumValue.label }}
                    </mat-option>
                  </mat-select>
                </mat-form-field>
              </span>
            </span>
          </div>
        </div>
      </div>
    </div>
    
    <div class="buttons">
      <button
        [ngClass]="showInitialValuesArgs ? 'initial' : 'notinitial'"
        type="button"
        mat-button
        color="accent"
        disableRipple="true"
        (click)="toggleInitialValues()"
      >
        <mat-icon>indeterminate_check_box</mat-icon>Toggle Initial Values
      </button>
      <button
        type="submit"
        mat-button
        color="accent"
        [disabled]="this.registrationForm.invalid"
      >
        <mat-icon>send</mat-icon> Send the Telecommand
      </button>
    </div>
  </form>
</div>

<router-outlet></router-outlet>
